---- #########################################################################
---- #graph                                                                  #
---- # edition du 25/11/20                                                   #
---- #                                                                       #
---- #########################################################################



local options = {
	{ "Source", SOURCE, 1 },
	{ "theme", VALUE ,5,0,27 },
	{ "Interval", VALUE, 3, 3, 35 }, 
	{ "Min", VALUE, 1024, -1024, 1024 },
	{ "Max", VALUE, -1024, -1024, 1024 }
}

local _maxPoints = 180
local value =0

function create(zone, options)
	local context = { zone=zone, options=options, points={}, lastTime=0, index=0 }
	return context
end

function update(context, options)
	if (context==nil) then
    print("update(nil)")
    return
	end
	context.options = options
	end

function refresh(context)
	updatePoints(context)
	drawGrap(context)
end

function background(context)
	updatePoints(context)
end

function updatePoints(context)
	local step =0
	local reset = getValue('ls59')
	 if reset > 100 then context.index = 0 end
	local step  =  getValue('ls60')
	 
	 if step > 100   then step = 0 
	 else step = 1
	 end
	 
	time = getTime()
   
	local delay = context.options.Interval * context.options.Interval 
	
	
		if time > context.lastTime + delay then
		value = getValue(context.options.Source)

		
		context.lastTime = time

		if(context.index < _maxPoints) or step == 0 then
			context.points[context.index] = value
			context.index = context.index + step
		else
			for i=1,_maxPoints - 1,1 do
				context.points[i - 1] = context.points[i]
			end
			context.points[_maxPoints - 1] = value
		end
		end
		collectgarbage()
	end

function drawGrap(context)

local theme_bg = {
	[0] = vide,
 	[1] = vide,
 	[2] = vide,
	[3] = vide,
 	[4] = vide,
 	[5] =GREY,
 	[6] = LIGHTGREY,
 	[7] = LIGHTGREY,
 	[8] =  GREY,  
 	[9] = '12676',   
 	[10] = '52273',  
	[11] = '52179', 
 	[12] = '12676', 
 	[13] = '67971', 
 	[14] = '911', 
 	[15] = '811', 
	[16] = '23403',
 	[17] = '35648',
 	[18] = '298',
 	[19] = '66186',
 	[20] = '67945',
 	[21] = '71748',
	[22] = '67971',
 	[23] = '66352',
 	[24] = '15574',
 	[25] = '67971', 
 	[26] = '54666',
 	[27] = '31441',  
 	}

local theme_alt = {
	[0] = WHITE,
 	[1]  = RED,
 	[2] =  YELLOW,
	[3] =  BLUE,
 	[4] =  BLACK,
 	[5]  = WHITE,
 	[6] = RED,
 	[7]  = BLACK,
 	[8] = YELLOW,
 	[9] = RED,
 	[10] = WHITE,  
	[11] = '68186', 
 	[12] = YELLOW,
 	[13] =YELLOW,
 	[14] = WHITE,
 	[15] =YELLOW,
 	[16] = WHITE,
	[17] =WHITE,
 	[18] = YELLOW,
 	[19] = RED,
 	[20] = YELLOW,
 	[21] = RED,
	[22] = YELLOW,
 	[23] = YELLOW,
 	[24] = WHITE,
 	[25] = WHITE,--nuit
 	[26] = WHITE,
 	[27] =  YELLOW,  
 	}

    if  context.options.theme  >27 then context.options.theme  = 12
	end




    local courbe = { pointsx={}, pointsy={} }
    local xPos = 0
	local yPos = 0
    local value = getValue(context.options.Source)


	local x = context.zone.x
	local y = context.zone.y
	local width = context.zone.w
	local height = context.zone.h
	if height< 80 then height = 80 end
	
    lcd.setColor(TEXT_COLOR, WHITE)   ----------------------------------------------------------------------------
	--lcd.setColor(CUSTOM_COLOR,theme_alt[context.options.theme])
	
	if  context.options.theme  >4 then
	lcd.setColor(TEXT_COLOR,theme_bg[context.options.theme])
	lcd.drawFilledRectangle(x, y, width, height, TEXT_COLOR) --******************************************************************
	end
	lcd.drawLine(x, y, x, y + height, SOLID, TEXT_COLOR)
	lcd.drawLine(x, y + height, x + width, y + height, SOLID, TEXT_COLOR)
	
    lcd.setColor(TEXT_COLOR,theme_alt[context.options.theme])
	if context.index == 0 then
		return
	end

	local dataMin = 9999
	local dataMax = -9999

	for i=0,context.index - 1,1 do
		if( context.points[i] > dataMax) then
			dataMax = context.points[i]
		end
	end

	for i=0,context.index - 1,1 do
		if( context.points[i] < dataMin) then
			dataMin = context.points[i]
		end
	end

	maxValue = context.options.Max
	minValue = context.options.Min

	 
		if(dataMin < minValue) then minValue = dataMin end
		if(dataMax > maxValue) then maxValue = dataMax end
	 

	--local zeroPos = 0  
	local range = (maxValue - minValue) 
	if range == 0 then 	range = 1 end
	
	local ratio = (height / range) 
	local previous_xPos = x
	

    local zeroPos =y + height * 0.1 +(maxValue )* ratio * 0.8
	if minValue < 1 and maxValue > 0 then
	   
		lcd.drawLine(x, zeroPos  , x + width, zeroPos, DOTTED, TEXT_COLOR)
		
		
	end

	
	local previous_yPos = y + height/2
	
	for i=0,context.index - 1,1 do
	courbe.pointsx[i] = x + (i * (context.zone.w / _maxPoints))
	courbe.pointsy[i] = y + (maxValue - context.points[i]) * ratio * 0.8 + (height * 0.1) 
	end
	
	
	for i=0,context.index - 1,1 do
		xPos = courbe.pointsx[i]  
		yPos =  courbe.pointsy[i]  
		lcd.drawLine(previous_xPos, previous_yPos, xPos, yPos, SOLID, TEXT_COLOR)
		previous_xPos = xPos
		previous_yPos = yPos
	end
	
	 
	 
		if range >= 100 then
			lcd.drawNumber(x + width, y + 1, value, TEXT_COLOR + RIGHT)
			lcd.drawNumber(x + 3, y + 1, maxValue, TEXT_COLOR)
			lcd.drawNumber(x + 3, y + height - 17, minValue, TEXT_COLOR)

			lcd.drawNumber(x + width - 1, y, value, TEXT_COLOR + RIGHT)
			lcd.drawNumber(x + 2, y, maxValue, TEXT_COLOR)
			lcd.drawNumber(x + 2, y + height - 18, minValue, TEXT_COLOR)
		else 
			if range >= 10 then
				lcd.drawNumber(x + width, y + 1, value * 10, TEXT_COLOR + RIGHT + PREC1)
				lcd.drawNumber(x + 3, y + 1, maxValue * 10, TEXT_COLOR + PREC1)
				lcd.drawNumber(x + 3, y + height - 17, minValue * 10, TEXT_COLOR + PREC1)

				lcd.drawNumber(x + width - 1, y, value * 10, TEXT_COLOR + RIGHT + PREC1)
				lcd.drawNumber(x + 2, y, maxValue * 10, TEXT_COLOR + PREC1)
				lcd.drawNumber(x + 2, y + height - 18, minValue * 10, TEXT_COLOR + PREC1)
			else
				lcd.drawNumber(x + width, y + 1, value * 100, TEXT_COLOR + RIGHT + PREC2)
				lcd.drawNumber(x + 3, y + 1, maxValue * 100, TEXT_COLOR + PREC2)
				lcd.drawNumber(x + 3, y + height - 17, minValue * 100, TEXT_COLOR + PREC2)

				lcd.drawNumber(x + width - 1, y, value * 100, TEXT_COLOR + RIGHT + PREC2)
				lcd.drawNumber(x + 2, y, maxValue * 100, TEXT_COLOR + PREC2)
				lcd.drawNumber(x + 2, y + height - 18, minValue * 100, TEXT_COLOR + PREC2)
				
			end
		end

		 --lcd.drawText(x + (width / 2)  , y + 40, " points "..context.index, BLACK)
		lcd.drawSource(x + (width / 2) - 20, y, context.options.Source, TEXT_COLOR)
		--lcd.setColor(TEXT_COLOR, BLACK)
		local delay = context.options.Interval 
		lcd.drawText(x +width -2, y + height - 18, delay, TEXT_COLOR + RIGHT )
		  -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
    if visu > 10 then 
    --lcd.setColor(TEXT_COLOR, BLACK)
	lcd.drawText( x +5 , y +38 ,"stop  ->  LS60 ON"  ,SMLSIZE + TEXT_COLOR) 
	lcd.drawText( x +5 , y +50 ,"reset ->  LS59 ON"  ,SMLSIZE + TEXT_COLOR) 
	end
	--lcd.setColor(TEXT_COLOR, BLACK) 
	----------------------------------------------------------------------------------------
	local reset = getValue('ls59')
	local step  =  getValue('ls60')
	
	if reset > 100 then 
	lcd.drawText( x +30 , y +40 ,"RESET"  ,SMLSIZE + TEXT_COLOR) 
	end
	local step  =  getValue('ls60')
	if step > 100 then
	lcd.drawText(x + width  ,y + height - 30 ,"STB "  ,SMLSIZE + RIGHT +  TEXT_COLOR) 
	else
	lcd.drawText(x + width  ,y + height - 30 ,"ON "  ,SMLSIZE + RIGHT +  TEXT_COLOR) 
	end
	collectgarbage()
end
        
return { name="Graph", options=options, create=create, update=update, refresh=refresh, background=background }
