---- #########################################################################
---- #bombe                                                                 #
---- # edition du 25/11/20                                                   #
---- #                                                                       #
---- #########################################################################


local Bitmaps30 = {}
local Bitmaps40 = {}

local options = {
  { "TextColor", COLOR, RED },
  { "Switch", SOURCE, 0},  -----------switch  d'armement de la bombe ( SE)
  { "Invert", BOOL, 0},
  { "LS_bombe_off", SOURCE, 0},           ---LS de bombe larguée LS10
}

local function create(zone, options)
  local wgt  = { zone=zone, options=options}
   return wgt
end

local function update(wgt, options)
  if (wgt==nil) then
    print("update(nil)")
    return
  end
  wgt.options = options
end

local function background(wgt)
  return
end

------------------------------------------------------------

local function getArmedStatus(wgt)
  local value = getValue(wgt.options.Switch)

 if wgt.options.Invert == 1 then
    value = -value
  end

  if value > 0 then
    return true
  else
    return false
  end
end

-- This size is for top bar wgts
local function refreshZoneTiny(wgt)
  local status = getArmedStatus(wgt)
  local largue = getValue(wgt.options.LS_bombe_off)
   
  if Bitmaps30[0] == nil then
    Bitmaps30[0] = Bitmap.open("/WIDGETS/bombe/on50.png")
    Bitmaps30[1] = Bitmap.open("/WIDGETS/bombe/off50.png")
  end
  
 if largue >1 then 
    lcd.drawBitmap(Bitmaps30[1], wgt.zone.x + -5 ,wgt.zone.y)
  else
    lcd.drawBitmap(Bitmaps30[0], wgt.zone.x + -5 ,wgt.zone.y) 
  end
  
  if status == true then
		if largue < 1 then 
		lcd.setColor(TEXT_COLOR,RED)
		lcd.drawText(wgt.zone.x + 10, wgt.zone.y + 5, "Armed", 0 + BLINK + TEXT_COLOR) 
		end
  else
		if largue < 1 then 
		lcd.drawText(wgt.zone.x + 15, wgt.zone.y + 5, "lock", MIDSIZE + CUSTOM_COLOR) 
		end
   
  end
  	  -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
   local cmde = wgt.options.Switch
    if visu > 10 then 
    lcd.setColor(TEXT_COLOR, WHITE)
	lcd.drawSource(wgt.zone.x +55 ,wgt.zone.y -1,cmde  ,SMLSIZE + TEXT_COLOR) 
	end

end

--- Size is 160x32 1/8th
local function refreshZoneSmall(wgt)
  local status = getArmedStatus(wgt)
  local largue = getValue(wgt.options.LS_bombe_off)
  
   if Bitmaps40[0] == nil then
    Bitmaps40[0] = Bitmap.open("/WIDGETS/bombe/on60.png")
    Bitmaps40[1] = Bitmap.open("/WIDGETS/bombe/off60.png")
  end
  
 if largue >1 then 
    lcd.drawBitmap(Bitmaps40[1], wgt.zone.x + 0 ,wgt.zone.y)
  else
    lcd.drawBitmap(Bitmaps40[0], wgt.zone.x + 0 ,wgt.zone.y) 
  end
  
   if status == true then
		if largue < 1 then
        lcd.setColor(TEXT_COLOR,RED)		
		lcd.drawText(wgt.zone.x + 10, wgt.zone.y + 5, "Armed", DBLSIZE + BLINK + TEXT_COLOR) 
		
		end
  else
		if largue < 1 then 
		lcd.drawText(wgt.zone.x + 15, wgt.zone.y + 5, "lock", DBLSIZE + CUSTOM_COLOR) 
		end
   
  end
    -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
   local cmd = wgt.options.Switch
   if visu > 10 then 
	lcd.drawSource(wgt.zone.x +10 ,wgt.zone.y +60,cmd  ,0) 
	end
	----------------------------------------------------------------------------------------
	
end

--- Size is 225x98 1/4th  (no sliders/trim)
local function refreshZoneMedium(wgt)
  
end

--- Size is 192x152 1/2
local function refreshZoneLarge(wgt)

end

--- Size is 390x172 1/1
--- Size is 460x252 1/1 (no sliders/trim/topbar)
local function refreshZoneXLarge(wgt)

end


function refresh(wgt)

  if (wgt==nil) then
    print("refresh(nil)")
    return
  end

  if (wgt.options==nil) then
    print("refresh(wgt.options=nil)")
    return
  end

    lcd.setColor(TEXT_COLOR, wgt.options.TextColor) 
    lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)

  if     wgt.zone.w  > 380 and wgt.zone.h > 165 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 180 and wgt.zone.h > 145 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 170 and wgt.zone.h >  65 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 150 and wgt.zone.h >  28 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  >  65 and wgt.zone.h >  35 then refreshZoneTiny(wgt)
  end
    lcd.setColor(TEXT_COLOR, BLACK) 
    lcd.setColor(CUSTOM_COLOR, BLACK)
  
end

return { name="bombe", options=options, create=create, update=update, background=background, refresh=refresh }
