---- #########################################################################
---- #                                                                       #
---- # croco                         #
---- # edition du 25/11/20                                                   #
---- #                                                                       #
---- #########################################################################

local Bitmaps30 = {}
local Bitmaps40 = {}

local options = {
  { "TextColor", COLOR, RED },
  { "activation", SOURCE, 110 },
  { "Invert", BOOL, 0},
  { "neutral", BOOL, 0},
}

local function create(zone, options)
  local wgt  = { zone=zone, options=options}
   return wgt
end

local function update(wgt, options)
  if (wgt==nil) then
    print("update(nil)")
    return
  end
  wgt.options = options
end

local function background(wgt)
  return
end

------------------------------------------------------------

local function getArmedStatus(wgt)
local value = getValue(wgt.options.activation)
  
  
  if wgt.options.Invert == 1 then
    value = -value
  end
	if wgt.options.neutral == 1 then
		if value > -10 then
		return true
		else
		return false
		end
  else
		if value >10 then
		return true
		else
		return false
		end
	end
 end

-- This size is for top bar wgts
local function refreshZoneTiny(wgt)
  local status = getArmedStatus(wgt)
 
  if Bitmaps30[0] == nil then
    Bitmaps30[0] = Bitmap.open("/WIDGETS/croco/crocoOFF50.png")
    Bitmaps30[1] = Bitmap.open("/WIDGETS/croco/crocoON50.png")
  end
 
  if status == true then
    lcd.drawBitmap(Bitmaps30[1], wgt.zone.x + 15,wgt.zone.y +0)
  else
    lcd.drawBitmap(Bitmaps30[0], wgt.zone.x + 15,wgt.zone.y +0)
  end
   -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
   local dualrate = wgt.options.activation
    if visu > 10 then 
    lcd.setColor(TEXT_COLOR, WHITE)
	lcd.drawSource(wgt.zone.x +45 ,wgt.zone.y -1,dualrate  ,SMLSIZE + TEXT_COLOR) 
	end
	lcd.setColor(TEXT_COLOR, BLACK) 
	----------------------------------------------------------------------------------------
  
end

--- Size is 160x32 1/8th
local function refreshZoneSmall(wgt)
  local status = getArmedStatus(wgt)
 
  if Bitmaps30[0] == nil then
    Bitmaps30[0] = Bitmap.open("/WIDGETS/croco/crocoOFF50.png")
    Bitmaps30[1] = Bitmap.open("/WIDGETS/croco/crocoON50.png")
  end
 
  if status == true then
    lcd.drawText(wgt.zone.x + 55, wgt.zone.y + 4, "ON", MIDSIZE + CUSTOM_COLOR) 
    lcd.drawBitmap(Bitmaps30[1], wgt.zone.x + 0,wgt.zone.y + 0)
  else
    lcd.drawText(wgt.zone.x + 55, wgt.zone.y + 4, "OFF", MIDSIZE + CUSTOM_COLOR) 
    lcd.drawBitmap(Bitmaps30[0], wgt.zone.x + 0,wgt.zone.y + 0)
  end
  
    -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
   local dualrate = wgt.options.activation
   local reset = wgt.options.Reset_MAX
   if visu > 10 then 
	lcd.drawSource(wgt.zone.x +50 ,wgt.zone.y +30,dualrate  ,0) 
	end
	----------------------------------------------------------------------------------------
  
end

--- Size is 225x98 1/4th  (no sliders/trim)
local function refreshZoneMedium(wgt)
  
end

--- Size is 192x152 1/2
local function refreshZoneLarge(wgt)

end

--- Size is 390x172 1/1
--- Size is 460x252 1/1 (no sliders/trim/topbar)
local function refreshZoneXLarge(wgt)

end


function refresh(wgt)

  if (wgt==nil) then
    print("refresh(nil)")
    return
  end

  if (wgt.options==nil) then
    print("refresh(wgt.options=nil)")
    return
  end

  lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)

  if     wgt.zone.w  > 380 and wgt.zone.h > 165 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 180 and wgt.zone.h > 145 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 170 and wgt.zone.h >  65 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 150 and wgt.zone.h >  28 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  >  65 and wgt.zone.h >  35 then refreshZoneTiny(wgt)
  end
   lcd.setColor(TEXT_COLOR, BLACK) 
   lcd.setColor(CUSTOM_COLOR, BLACK)
end

return { name="CROCO", options=options, create=create, update=update, background=background, refresh=refresh }
