---- #########################################################################
---- #                                                                       #
---- # GYRO                                                                  #
---- # edition du 19/12/20                                                   #
---- #                                                                       #
---- #########################################################################

local Bitmaps30 = {}
local Bitmaps40 = {}
local activation = 0

local options = {
  { "TextColor", COLOR, RED },
  { "LSActivation", SOURCE, 0},
  { "Invert", BOOL, 0},
  {"Switch_ON", SOURCE, 0},
  
}

local function create(zone, options)
  local wgt  = { zone=zone, options=options}
   return wgt
end

local function update(wgt, options)
  if (wgt==nil) then
    print("update(nil)")
    return
  end
  wgt.options = options
end

local function background(wgt)
  return
end

------------------------------------------------------------

local function getArmedStatus(wgt)
  local value = getValue(wgt.options.LSActivation)

 if wgt.options.Invert == 1 then
    value = -value
  end
  
 if value > 10 and activation == 0 then 
        playTone (700,100,100,0)
		playTone (700,100,250,0)
		--playFile("/SOUNDS/fr/nivbat.wav")
  activation = 1
  end
  if value < 10 and activation == 1 then 
        playTone (300,100,100,0)
		playTone (300,100,250,0)
		--playFile("/SOUNDS/fr/nivbat.wav")
  activation = 0
  end
  
  if value > 10 then
    return true
  else
    return false
  end
  
  
  
end

-- This size is for top bar wgts
local function refreshZoneTiny(wgt)
  local status = getArmedStatus(wgt)
 
  if Bitmaps30[0] == nil then
    Bitmaps30[0] = Bitmap.open("/WIDGETS/gyro/gyrooff40.png")
    Bitmaps30[1] = Bitmap.open("/WIDGETS/gyro/gyroon40.png")
  end
 
  if status == true then
    lcd.drawBitmap(Bitmaps30[1], wgt.zone.x + 10,wgt.zone.y )
  else
    lcd.drawBitmap(Bitmaps30[0], wgt.zone.x + 10,wgt.zone.y )
  end
   -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
   local gyro = wgt.options.Switch_ON
    if visu > 10 then 
    lcd.setColor(TEXT_COLOR, WHITE)
	lcd.drawSource(wgt.zone.x +20 ,wgt.zone.y -1,gyro  ,SMLSIZE + TEXT_COLOR) 
	lcd.setColor(TEXT_COLOR, BLACK)
    end
	----------------------------------------------------------------------------------------
  
  
  
end

--- Size is 160x32 1/8th
local function refreshZoneSmall(wgt)
  local status = getArmedStatus(wgt)
 
  if Bitmaps30[0] == nil then
    Bitmaps30[0] = Bitmap.open("/WIDGETS/gyro/gyrooff40.png")
    Bitmaps30[1] = Bitmap.open("/WIDGETS/gyro/gyroon40.png")
  end
 
  if status == true then
    lcd.drawText(wgt.zone.x + 45, wgt.zone.y + 5, "GYRO ON", MIDSIZE + CUSTOM_COLOR) 
    lcd.drawBitmap(Bitmaps30[1], wgt.zone.x,wgt.zone.y)
  else
    lcd.drawText(wgt.zone.x + 45, wgt.zone.y + 5, "GYRO OFF", MIDSIZE +CUSTOM_COLOR)
    lcd.drawBitmap(Bitmaps30[0], wgt.zone.x,wgt.zone.y)
  end
  -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
   local gyro = wgt.options.Switch_ON
    if visu > 10 then 
    lcd.setColor(TEXT_COLOR, WHITE)
	lcd.drawSource(wgt.zone.x +10 ,wgt.zone.y -1,gyro  ,SMLSIZE + TEXT_COLOR) 
	lcd.setColor(TEXT_COLOR, BLACK)
    end
	----------------------------------------------------------------------------------------
  
end

--- Size is 225x98 1/4th  (no sliders/trim)
local function refreshZoneMedium(wgt)
 
end

--- Size is 192x152 1/2
local function refreshZoneLarge(wgt)

end

--- Size is 390x172 1/1
--- Size is 460x252 1/1 (no sliders/trim/topbar)
local function refreshZoneXLarge(wgt)

end


function refresh(wgt)

  if (wgt==nil) then
    print("refresh(nil)")
    return
  end

  if (wgt.options==nil) then
    print("refresh(wgt.options=nil)")
    return
  end

  lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)

  if     wgt.zone.w  > 380 and wgt.zone.h > 165 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 180 and wgt.zone.h > 145 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 170 and wgt.zone.h >  65 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 150 and wgt.zone.h >  28 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  >  65 and wgt.zone.h >  35 then refreshZoneTiny(wgt)
  end
   lcd.setColor(TEXT_COLOR, BLACK) 
    lcd.setColor(CUSTOM_COLOR, BLACK)
end

return { name="gyro", options=options, create=create, update=update, background=background, refresh=refresh }
