---- #########################################################################
---- #                                                                       #
---- # mixage derive                        #
---- # edition du 25/11/20                                                   #
---- #                                                                       #
---- #########################################################################

local Bitmaps30 = {}
local Bitmaps40 = {}

local options = {
  { "TextColor", COLOR, WHITE },
  { "activation", SOURCE, 0},
  { "Invert", BOOL, 0},
}

local function create(zone, options)
  local wgt  = { zone=zone, options=options}
   return wgt
end

local function update(wgt, options)
  if (wgt==nil) then
    print("update(nil)")
    return
  end
  wgt.options = options
end

local function background(wgt)
  return
end

------------------------------------------------------------

local function getArmedStatus(wgt)
 local value = getValue(wgt.options.activation)

  if wgt.options.Invert == 1 then
    value = -value
  end

  return value
  end





-- This size is for top bar wgts
local function refreshZoneTiny(wgt)
   local status = getArmedStatus(wgt)
   lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)
   lcd.drawText(wgt.zone.x, wgt.zone.y + 0, "MIXAGE", 0 + CUSTOM_COLOR)
 
  if status > 100  then
  lcd.drawText(wgt.zone.x, wgt.zone.y + 20, "MAX", 0 + CUSTOM_COLOR)
  elseif status < -100 then
   lcd.drawText(wgt.zone.x, wgt.zone.y + 20, "OFF", 0 + CUSTOM_COLOR)
   else
   lcd.drawText(wgt.zone.x, wgt.zone.y + 20, "MOY", 0 + CUSTOM_COLOR)
  end
  
   -----------------------------------------------------------------------------------
   local visu = getValue('sh')   -------------------------SH
   local active = wgt.options.activation
    if visu > 10 then 
    lcd.setColor(TEXT_COLOR, WHITE)
	lcd.drawSource(wgt.zone.x +45 ,wgt.zone.y + 20,active  ,SMLSIZE + TEXT_COLOR) 
	end
	lcd.setColor(TEXT_COLOR, BLACK) 
	---------------------------------------------------------------------------------
  
end

--- Size is 160x32 1/8th
local function refreshZoneSmall(wgt)
  
  
end

--- Size is 225x98 1/4th  (no sliders/trim)
local function refreshZoneMedium(wgt)
  
end

--- Size is 192x152 1/2
local function refreshZoneLarge(wgt)

end

--- Size is 390x172 1/1
--- Size is 460x252 1/1 (no sliders/trim/topbar)
local function refreshZoneXLarge(wgt)

end


function refresh(wgt)

  if (wgt==nil) then
    print("refresh(nil)")
    return
  end

  if (wgt.options==nil) then
    print("refresh(wgt.options=nil)")
    return
  end

  lcd.setColor(CUSTOM_COLOR, wgt.options.TextColor)

  if     wgt.zone.w  > 380 and wgt.zone.h > 165 then refreshZoneXLarge(wgt)
  elseif wgt.zone.w  > 180 and wgt.zone.h > 145 then refreshZoneLarge(wgt)
  elseif wgt.zone.w  > 170 and wgt.zone.h >  65 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  > 150 and wgt.zone.h >  28 then refreshZoneSmall(wgt)
  elseif wgt.zone.w  >  65 and wgt.zone.h >  35 then refreshZoneTiny(wgt)
  end
   lcd.setColor(TEXT_COLOR, BLACK) 
   lcd.setColor(CUSTOM_COLOR, BLACK)
end

return { name="mix_deri", options=options, create=create, update=update, background=background, refresh=refresh }
